<?php 

$global_settings = FLBuilderModel::get_global_settings();

FLBuilder::register_settings_form('row', array(
    'title' => __('Row Settings', 'fl-builder'),
    'tabs' => array(
        'style'         => array(
            'title'         => __('Style', 'fl-builder'),
            'sections'      => array(
                'general'       => array(
                    'title'         => '',
                    'fields'        => array(
                        'width'         => array(
                            'type'          => 'select',
                            'label'         => __('Width', 'fl-builder'),
                            'default'       => 'fixed',
                            'options'       => array(
                                'fixed'         => __('Fixed', 'fl-builder'),
                                'full'          => __('Full Width', 'fl-builder')
                            ),
                            'toggle'        => array(
                                'full'         => array(
                                    'fields'        => array('content_width')
                                )
                            ),
                            'help'          => __('Full width rows span the width of the page from edge to edge. Fixed rows are no wider than the Row Max Width set in the Global Settings.', 'fl-builder'),
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        ),
                        'content_width'  => array(
                            'type'          => 'select',
                            'label'         => __('Content Width', 'fl-builder'),
                            'default'       => 'fixed',
                            'options'       => array(
                                'fixed'         => __('Fixed', 'fl-builder'),
                                'full'          => __('Full Width', 'fl-builder')
                            ),
                            'help'          => __('Full width content spans the width of the page from edge to edge. Fixed content is no wider than the Row Max Width set in the Global Settings.', 'fl-builder'),
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        ),
                    )
                ),
                'text'          => array(
                    'title'         => __('Text', 'fl-builder'),
                    'fields'        => array(
                        'text_color'    => array(
                            'type'          => 'color',
                            'label'         => __('Color', 'fl-builder'),
                            'show_reset'    => true,
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        )
                    )
                ),
                'background'    => array(
                    'title'         => __('Background', 'fl-builder'),
                    'fields'        => array(
                        'bg_type'      => array(
                            'type'          => 'select',
                            'label'         => __('Type', 'fl-builder'),
                            'default'       => 'none',
                            'options'       => array(
                                'none'          => __('None', 'fl-builder'),
                                'color'         => __('Color', 'fl-builder'),
                                'photo'         => __('Photo', 'fl-builder'),
                                'video'         => __('Video', 'fl-builder'),
                                'slideshow'     => array(
                                    'label'         => __('Slideshow', 'fl-builder'),
                                    'premium'       => true
                                ),
                                'parallax'     => array(
                                    'label'         => __('Parallax', 'fl-builder'),
                                    'premium'       => true
                                )
                            ),
                            'toggle'        => array(
                                'color'         => array(
                                    'sections'      => array('bg_color')
                                ),
                                'photo'         => array(
                                    'sections'      => array('bg_photo')
                                ),
                                'video'         => array(
                                    'sections'      => array('bg_video')
                                ),
                                'slideshow'     => array(
                                    'sections'      => array('bg_slideshow')
                                ),
                                'parallax'      => array(
                                    'sections'      => array('bg_parallax')
                                )
                            ),
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        )
                    )
                ),
                'bg_color'     => array(
                    'title'         => __('Background Color', 'fl-builder'),
                    'fields'        => array(
                        'bg_color'      => array(
                            'type'          => 'color',
                            'label'         => __('Color', 'fl-builder'),
                            'show_reset'    => true,
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        ),
                        'bg_opacity'    => array(
                            'type'          => 'text',
                            'label'         => __('Opacity', 'fl-builder'),
                            'default'       => '100',
                            'description'   => '%',
                            'maxlength'     => '3',
                            'size'          => '5',
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        )
                    )   
                ),
                'bg_photo'     => array(
                    'title'         => __('Background Photo', 'fl-builder'),
                    'fields'        => array(
                        'bg_image'      => array(
                            'type'          => 'photo',
                            'label'         => __('Photo', 'fl-builder'),
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        ),
                        'bg_repeat'     => array(
                            'type'          => 'select',
                            'label'         => __('Repeat', 'fl-builder'),
                            'default'       => 'none',
                            'options'       => array(
                                'no-repeat'     => __('None', 'fl-builder'),
                                'repeat'        => __('Tile', 'fl-builder'),
                                'repeat-x'      => __('Horizontal', 'fl-builder'),
                                'repeat-y'      => __('Vertical', 'fl-builder')
                            ),
                            'help'          => __('Repeat applies to how the image should display in the row background. Choosing none will display the image as uploaded. Tile will repeat the image as many times as needed to fill the row horizontally and vertically. You can also specify the image to only repeat horizontally or vertically.', 'fl-builder'),
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        ),
                        'bg_position'   => array(
                            'type'          => 'select',
                            'label'         => __('Position', 'fl-builder'),
                            'default'       => 'center center',
                            'options'       => array(
                                'left top'      => __('Left Top', 'fl-builder'),
                                'left center'   => __('Left Center', 'fl-builder'),
                                'left bottom'   => __('Left Bottom', 'fl-builder'),
                                'right top'     => __('Right Top', 'fl-builder'),
                                'right center'  => __('Right Center', 'fl-builder'),
                                'right bottom'  => __('Right Bottom', 'fl-builder'),
                                'center top'    => __('Center Top', 'fl-builder'),
                                'center center' => __('Center Center', 'fl-builder'),
                                'center bottom' => __('Center Bottom', 'fl-builder')
                            ),
                            'help'          => __('Position will tell the image where it should sit in the row background.', 'fl-builder'),
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        ),
                        'bg_attachment' => array(
                            'type'          => 'select',
                            'label'         => __('Attachment', 'fl-builder'),
                            'default'       => 'scroll',
                            'options'       => array(
                                'scroll'        => __('Scroll', 'fl-builder'),
                                'fixed'         => __('Fixed', 'fl-builder')
                            ),
                            'help'          => __('Attachment will specify how the image reacts when scrolling a page. When scrolling is selected, the image will scroll with page scrolling. This is the default setting. Fixed will allow the image to scroll within the row background if fill is selected in the scale setting.', 'fl-builder'),
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        ),
                        'bg_size'       => array(
                            'type'          => 'select',
                            'label'         => __('Scale', 'fl-builder'),
                            'default'       => 'cover',
                            'options'       => array(
                                ''              => __('None', 'fl-builder'),
                                'contain'       => __('Fit', 'fl-builder'),
                                'cover'         => __('Fill', 'fl-builder')
                            ),
                            'help'          => __('Scale applies to how the image should display in the row background. You can select either fill or fit to the row background.', 'fl-builder'),
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        )
                    )
                ),
                'bg_video'     => array(
                    'title'         => __('Background Video', 'fl-builder'),
                    'fields'        => array(
                        'bg_video'      => array(
                            'type'          => 'video',
                            'label'         => __('Video', 'fl-builder'),
                            'help'          => __('An HTML5 video to use as the background of this row. Supported types are MP4, WebM and Ogg.', 'fl-builder'),
                            'preview'         => array(
                                'type'            => 'refresh'
                            )
                        ),
                        'bg_video_fallback' => array(
                            'type'          => 'photo',
                            'label'         => __('Fallback Photo', 'fl-builder'),
                            'help'          => __('A photo that will be displayed if the video fails to load.', 'fl-builder'),
                            'preview'         => array(
                                'type'            => 'refresh'
                            )
                        )
                    )
                ),
                'bg_slideshow' => array(
                    'title'         => __('Background Slideshow', 'fl-builder'),
                    'fields'        => array(
                        'ss_source'     => array(
                            'type'          => 'select',
                            'label'         => __('Source', 'fl-builder'),
                            'default'       => 'wordpress',
                            'options'       => array(
                                'wordpress'     => __('Media Library', 'fl-builder'),
                                'smugmug'       => __('SmugMug', 'fl-builder')
                            ),
    						'help'          => __('Pull images from the WordPress media library or a gallery on your SmugMug site by inserting the RSS feed URL from SmugMug. The RSS feed URL can be accessed by using the get a link function in your SmugMug gallery.', 'fl-builder'),
                            'toggle'        => array(
                                'wordpress'      => array(
                                    'fields'        => array('ss_photos')
                                ),
                                'smugmug'        => array(
                                    'fields'        => array('ss_feed_url')
                                )
                            ),
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        ),
                        'ss_photos'     => array(
                            'type'          => 'multiple-photos',
                            'label'         => __('Photos', 'fl-builder'),
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        ),
                        'ss_feed_url'   => array(
                            'type'          => 'text',
                            'label'         => __('Feed URL', 'fl-builder'),
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        ),
                        'ss_speed'      => array(
                            'type'          => 'text',
                            'label'         => __('Speed', 'fl-builder'),
                            'default'       => '3',
                            'size'          => '5',
                            'description'   => __('seconds', 'fl-builder'),
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        ),
                        'ss_transition' => array(
                            'type'          => 'select',
                            'label'         => __('Transition', 'fl-builder'),
                            'default'       => 'fade',
                            'options'       => array(
                                'none'              => __('None', 'fl-builder'),
                                'fade'              => __('Fade', 'fl-builder'),
                                'kenBurns'          => __('Ken Burns', 'fl-builder'),
                                'slideHorizontal'   => __('Slide Horizontal', 'fl-builder'),
                                'slideVertical'     => __('Slide Vertical', 'fl-builder'),
                                'blinds'            => __('Blinds', 'fl-builder'),
                                'bars'              => __('Bars', 'fl-builder'),
                                'barsRandom'        => __('Random Bars', 'fl-builder'),
                                'boxes'             => __('Boxes', 'fl-builder'),
                                'boxesRandom'       => __('Random Boxes', 'fl-builder'),
                                'boxesGrow'         => __('Boxes Grow', 'fl-builder')
                            ),
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        ),
                        'ss_transitionDuration' => array(
                            'type'          => 'text',
                            'label'         => __('Transition Speed', 'fl-builder'),
                            'default'       => '1',
                            'size'          => '5',
                            'description'   => __('seconds', 'fl-builder'),
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        ),
                        'ss_randomize'  => array(
                            'type'          => 'select',
                            'label'         => __('Randomize Photos', 'fl-builder'),
                            'default'       => 'false',
                            'options'       => array(
                                'false'         => __('No', 'fl-builder'),
                                'true'          => __('Yes', 'fl-builder')
                            ),
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        )
                    )
                ),
                'bg_parallax'   => array(
                    'title'         => __('Background Parallax', 'fl-builder'),
                    'fields'        => array(
                        'bg_parallax_image' => array(
                            'type'          => 'photo',
                            'label'         => __('Photo', 'fl-builder'),
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        ),
                        'bg_parallax_speed' => array(
                            'type'          => 'select',
                            'label'         => __('Speed', 'fl-builder'),
                            'default'       => 'fast',
                            'options'       => array(
                                '2'             => __('Fast', 'fl-builder'),
                                '5'             => __('Medium', 'fl-builder'),
                                '8'             => __('Slow', 'fl-builder')
                            ),
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        )
                    )
                ),
                'border'       => array(
                    'title'         => __('Border', 'fl-builder'),
                    'fields'        => array(
                        'border_type'   => array(
                            'type'          => 'select',
                            'label'         => __('Type', 'fl-builder'),
                            'default'       => '',
                            'help'          => __('The type of border to use. Double borders must have a width of at least 3px to render properly.', 'fl-builder'),
                            'options'       => array(
                                ''              => __('None', 'fl-builder'),
                                'solid'         => __('Solid', 'fl-builder'),
                                'dashed'        => __('Dashed', 'fl-builder'),
                                'dotted'        => __('Dotted', 'fl-builder'),
                                'double'        => __('Double', 'fl-builder')
                            ),
                            'toggle'        => array(
                                ''              => array(
                                    'fields'        => array()
                                ),
                                'solid'         => array(
                                    'fields'        => array('border_color', 'border_opacity', 'border_top', 'border_bottom', 'border_left', 'border_right')
                                ),
                                'dashed'        => array(
                                    'fields'        => array('border_color', 'border_opacity', 'border_top', 'border_bottom', 'border_left', 'border_right')
                                ),
                                'dotted'        => array(
                                    'fields'        => array('border_color', 'border_opacity', 'border_top', 'border_bottom', 'border_left', 'border_right')
                                ),
                                'double'        => array(
                                    'fields'        => array('border_color', 'border_opacity', 'border_top', 'border_bottom', 'border_left', 'border_right')
                                )
                            ),
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        ),
                        'border_color'  => array(
                            'type'          => 'color',
                            'label'         => __('Color', 'fl-builder'),
                            'show_reset'    => true,
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        ),
                        'border_opacity' => array(
                            'type'          => 'text',
                            'label'         => __('Opacity', 'fl-builder'),
                            'default'       => '100',
                            'description'   => '%',
                            'maxlength'     => '3',
                            'size'          => '5',
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        ),
                        'border_top'    => array(
                            'type'          => 'text',
                            'label'         => __('Top Width', 'fl-builder'),
                            'default'       => '1',
                            'description'   => __('px', 'fl-builder'),
                            'maxlength'     => '3',
                            'size'          => '5',
                            'placeholder'   => '0',
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        ),
                        'border_bottom' => array(
                            'type'          => 'text',
                            'label'         => __('Bottom Width', 'fl-builder'),
                            'default'       => '1',
                            'description'   => __('px', 'fl-builder'),
                            'maxlength'     => '3',
                            'size'          => '5',
                            'placeholder'   => '0',
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        ),
                        'border_left'   => array(
                            'type'          => 'text',
                            'label'         => __('Left Width', 'fl-builder'),
                            'default'       => '0',
                            'description'   => __('px', 'fl-builder'),
                            'maxlength'     => '3',
                            'size'          => '5',
                            'placeholder'   => '0',
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        ),
                        'border_right'  => array(
                            'type'          => 'text',
                            'label'         => __('Right Width', 'fl-builder'),
                            'default'       => '0',
                            'description'   => __('px', 'fl-builder'),
                            'maxlength'     => '3',
                            'size'          => '5',
                            'placeholder'   => '0',
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        )
                    )
                ),
            )
        ),
        'advanced'      => array(
            'title'         => __('Advanced', 'fl-builder'),
            'sections'      => array(
                'general'       => array(
                    'title'         => '',
                    'fields'        => array(
                        'class'         => array(
                            'type'          => 'text',
                            'label'         => __('CSS Class', 'fl-builder'),
                            'help'          => __('Add a custom CSS selector here to apply additional styling to this row.', 'fl-builder'),
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        ),
                        'responsive_display' => array(
                            'type'          => 'select',
                            'label'         => __('Display', 'fl-builder'),
                            'options'       => array(
                                ''              => __('Always', 'fl-builder'),
                                'desktop'       => __('Desktop Only', 'fl-builder'),
                                'mobile'        => __('Mobile Only', 'fl-builder'),
                            ),
                            'help'          => __('Choose whether to always show this row, only show it on the desktop view or only show it on the mobile view.'),
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        )
                    )
                ),
                'margins'       => array(
                    'title'         => __('Margins', 'fl-builder'),
                    'fields'        => array(
                        'margin_top'    => array(
                            'type'          => 'text',
                            'label'         => __('Top', 'fl-builder'),
                            'default'       => '',
                            'description'   => __('px', 'fl-builder'),
                            'maxlength'     => '4',
                            'size'          => '5',
                            'placeholder'   => $global_settings->row_margins,
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        ),
                        'margin_bottom' => array(
                            'type'          => 'text',
                            'label'         => __('Bottom', 'fl-builder'),
                            'default'       => '',
                            'description'   => __('px', 'fl-builder'),
                            'maxlength'     => '4',
                            'size'          => '5',
                            'placeholder'   => $global_settings->row_margins,
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        ),
                        'margin_left'   => array(
                            'type'          => 'text',
                            'label'         => __('Left', 'fl-builder'),
                            'default'       => '',
                            'description'   => __('px', 'fl-builder'),
                            'maxlength'     => '4',
                            'size'          => '5',
                            'placeholder'   => $global_settings->row_margins,
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        ),
                        'margin_right'  => array(
                            'type'          => 'text',
                            'label'         => __('Right', 'fl-builder'),
                            'default'       => '',
                            'description'   => __('px', 'fl-builder'),
                            'maxlength'     => '4',
                            'size'          => '5',
                            'placeholder'   => $global_settings->row_margins,
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        )
                    )
                ),
                'padding'       => array(
                    'title'         => __('Padding', 'fl-builder'),
                    'fields'        => array(
                        'padding_top'   => array(
                            'type'          => 'text',
                            'label'         => __('Top', 'fl-builder'),
                            'default'       => '',
                            'description'   => __('px', 'fl-builder'),
                            'maxlength'     => '4',
                            'size'          => '5',
                            'placeholder'   => $global_settings->row_padding,
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        ),
                        'padding_bottom' => array(
                            'type'          => 'text',
                            'label'         => __('Bottom', 'fl-builder'),
                            'default'       => '',
                            'description'   => __('px', 'fl-builder'),
                            'maxlength'     => '4',
                            'size'          => '5',
                            'placeholder'   => $global_settings->row_padding,
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        ),
                        'padding_left'  => array(
                            'type'          => 'text',
                            'label'         => __('Left', 'fl-builder'),
                            'default'       => '',
                            'description'   => __('px', 'fl-builder'),
                            'maxlength'     => '4',
                            'size'          => '5',
                            'placeholder'   => $global_settings->row_padding,
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        ),
                        'padding_right' => array(
                            'type'          => 'text',
                            'label'         => __('Right', 'fl-builder'),
                            'default'       => '',
                            'description'   => __('px', 'fl-builder'),
                            'maxlength'     => '4',
                            'size'          => '5',
                            'placeholder'   => $global_settings->row_padding,
                            'preview'         => array(
                                'type'            => 'none'
                            )
                        )
                    )
                )
            )
        )
    )
));